//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "sivia.h"
#include "repere.h"
#include "box.h"


//---------------------------------------------------------------------------
#pragma package(smart_init)
//----------------------------------------------------------------------
#define ny 6

repere R;
box Y(ny,true);
int q,option;

iboolean Inside(box& P)
{   iboolean dedans;
    int n1=0,n2=0;
    for (int i=1;i<=ny;i++)
    {   interval a=(SqrtPos(2*3.1415*P[2]));
        interval Ym=(1/a)*Exp(-0.5*Sqr(i-P[1])/P[2]);
        iboolean m=(In(Ym,Y[i]));
        if (m==itrue)    {n1++;n2++;};
        if (m==iperhaps) {n2++;};
    }
    if ((n1==ny-q)&&(n2==ny-q))
    {   double p1=Center(P[1]);
        double p2=Center(P[2]);
        if (option==2)
        for (int k=0;k<=10000;k++)
        {       double x=0.001*k;
                double a=(sqrt(2*3.1415*p2));
                double y=(1/a)*exp(-0.5*(x-p1)*(x-p1)/p2);
                R.DrawPoint(x,y,clGray,1);
        };
        return itrue;
    }
    if (n1>ny-q) return ifalse;
    if (n2<ny-q) return ifalse;
    return iperhaps;
};
//----------------------------------------------------------------------
iboolean SIVIA(box& P)
{   box P1(2,true);
    box P2(2,true);
    if (Width(P)<0.005)
    {   if (option==1)  R.DrawBox(P,clWhite,clWhite,bsSolid);
        return iperhaps;
    };
    iboolean test=Inside(P);
    if (test==itrue)   {return itrue;}
    if (test==ifalse)  {return ifalse;}
    Bisect(P,P1,P2);
    iboolean c1=SIVIA(P1);
    iboolean c2=SIVIA(P2);
    if (c1==c2) return c1;
    if (option==1)
    {   if (c1==itrue) R.DrawBox(P1,clGray,clBlack,bsSolid);
        if (c2==itrue) R.DrawBox(P2,clGray,clBlack,bsSolid);
        if (c1==ifalse) R.DrawBox(P1,clLtGray,clWhite,bsSolid);
        if (c2==ifalse) R.DrawBox(P2,clLtGray,clWhite,bsSolid);
    }
    return iperhaps;
} ;
//----------------------------------------------------------------------
void GO(repere& R1,box& P,int q1, int option1)
{   R=R1;
    q=q1;
    option=option1;
    Y[1]=interval(0,0.2);
    Y[2]=interval(0.3,2);
    Y[3]=interval(0.3,2);
    Y[4]=interval(0.1,0.2);
    Y[5]=interval(0.4,2);
    //Y[5]=interval(0,1);
    Y[6]=interval(-1,0.1);
    if (option==2)
    {   box t(ny,true);
        t[1]=1;t[2]=2;t[3]=3;t[4]=4;t[5]=5;t[6]=6;
        R.DrawData (Y,t,clBlack,0.02);
    }
    iboolean c=SIVIA(P);
    if (option==1)
    {   if (c==itrue) R.DrawBox(P,clRed,clPurple,bsSolid);
        if (c==ifalse) R.DrawBox(P,clBlue,clOlive,bsSolid);
    }
    if (option==2)
    {   box t(ny,true);
        t[1]=1;t[2]=2;t[3]=3;t[4]=4;t[5]=5;t[6]=6;
        R.DrawData (Y,t,clBlack,0.02);
    }
} ;
//----------------------------------------------------------------------


