#include "treeop.h"

extern int dimp=-999;


tree_number::tree_number(node* l) {pnode=l;} ;
tree_number::tree_number() {pnode=NULL;} ;

tree_number operator+ (const tree_number& t1,const tree_number& t2)
{   return tree_number(new node('+',t1.pnode,t2.pnode));}

tree_number operator- (tree_number& t1, tree_number& t2)
{   return tree_number(new node('-',t1.pnode,t2.pnode));}

tree_number operator* (const tree_number& t1,const tree_number& t2)
{   return tree_number(new node('*',t1.pnode,t2.pnode));}

tree_number operator- (tree_number& t1)
{   return tree_number(new node('-',t1.pnode,NULL));}


tree_number Sin (tree_number& t1)
{ node* p1=new node('s',t1.pnode,NULL);
  tree_number r(p1);
  return r;
};

tree_number Cos (tree_number& t1)
{ node* p1=new node('c',t1.pnode,NULL);
  tree_number r(p1);
  return r;
};
tree_number Exp (const tree_number& t1)
{ node* p1=new node('e',t1.pnode,NULL);
  tree_number r(p1);
  return r;
};




//////////////////////


node::node (char code1,interval a)     //C'est une constante
{   code='0'; arg1=NULL; arg2=NULL; i=0; f=a;
    df=box(dimp,true);
    f0=-999;
    d1f0=-999;
    called=0;
};

node::~node ()
{   if (called!=0) cout<<"\n ERROR destructor node";
}

node::node(int i1)    //C'est une input
{   code='i'; arg1=NULL; arg2=NULL; i=i1;f=-999;
    df=box(dimp,true);
    f0=-999;
    called=0;
};

node::node (char op1,node* a1,node* a2)
{   code=op1; arg1=a1;   arg2=a2;   i=0; f=-999;
    df=box(dimp,true);
    f0=-999;
    called=0;
    if (arg1!=NULL) arg1->called++;
    if (arg2!=NULL) arg2->called++;
};

void node::ieval() //evalue l'arbre lorsque les pi sont des intervalles
{  	 switch (code)
	 {  case '0':  break;
        case 'i':  break;
	    case '-':
            if (arg2==NULL)	{arg1->ieval();f=-(arg1->f);break;}
		    else  {arg1->ieval();arg2->ieval();f=(arg1->f)-(arg2->f);break;};
	    case '+': {arg1->ieval();arg2->ieval();f=(arg1->f)+(arg2->f);break;};
	    case '*': {arg1->ieval();arg2->ieval();f=(arg1->f)*(arg2->f);break;};
        case 's': {arg1->ieval();f=Sin(arg1->f);break;};
        case 'c': {arg1->ieval();f=Cos(arg1->f);break;};
        case 'e': {arg1->ieval();f=Exp(arg1->f);break;};
        default : printf("Bogue ieval\n");
    } ;
};

void node::reval() //evalue l'arbre lorsque les pi sont des reels
{  	 switch (code)
	 {  case '0':  break;
        case 'i':  break;
	    case '-':
            if (arg2==NULL)	{arg1->reval();f0=-(arg1->f0);break;}
		    else  {arg1->reval();arg2->reval();f0=(arg1->f0)-(arg2->f0);break;};
	    case '+': {arg1->reval();arg2->reval();f0=(arg1->f0)+(arg2->f0);break;};
	    case '*': {arg1->reval();arg2->reval();f0=(arg1->f0)*(arg2->f0);break;};
        case 's': {arg1->reval();f0=sin(arg1->f0);break;};
        case 'c': {arg1->reval();f0=cos(arg1->f0);break;};
        case 'e': {arg1->reval();f0=exp(arg1->f0);break;};
        default : printf("Bogue eval\n");
    } ;
};

void node::d1reval() //evalue la derivee de l'arbre lorsque
                     //ce dernier represente une fonction a une seule variable
                     //Il faut faire un reval avant.
{  	 switch (code)
	 {  case '0':  break;  //initialisee par la produre appelenante
        case 'i':  break;  //idem
	    case '-':
            if (arg2==NULL)	{arg1->d1reval();d1f0=-(arg1->d1f0);break;}
		    else  {arg1->d1reval();arg2->d1reval();d1f0=(arg1->d1f0)-(arg2->d1f0);break;};
	    case '+': {arg1->d1reval();arg2->d1reval();d1f0=(arg1->d1f0)+(arg2->d1f0);break;};
	    case '*': {arg1->d1reval();arg2->d1reval();
                   d1f0=(arg1->d1f0)*(arg2->f0)+(arg2->d1f0)*(arg1->f0);
                   ;break;};
        case 's': {arg1->d1reval();d1f0=cos(arg1->f0)*arg1->d1f0;break;};
        case 'c': {arg1->d1reval();d1f0=-sin(arg1->f0)*arg1->d1f0;break;};
        case 'e': {arg1->d1reval();d1f0=exp(arg1->f0)*arg1->d1f0;break;};
        default : printf("Bogue eval\n");
    } ;
};

void node::d2reval() //evalue la derivee seconde de l'arbre lorsque
                     //ce dernier represente une fonction a une seule variable
                     //Il faut faire un reval et un deval avant.
{  	 switch (code)
	 {  case '0':  break;  //initialisee par la procedure appelante
        case 'i':  break;  //idem
	    case '-':
            if (arg2==NULL)	{arg1->d2reval();d2f0=-(arg1->d2f0);break;}
		    else  { arg1->d2reval();arg2->d2reval();
                    d2f0=(arg1->d2f0)-(arg2->d2f0);
                    break;};
	    case '+': { arg1->d2reval();arg2->d2reval();
                    d2f0=(arg1->d2f0)+(arg2->d2f0);
                    break;};
	    case '*': { arg1->d2reval();arg2->d2reval();
                    d2f0=(arg1->d2f0)*(arg2->f0)
                        +(arg2->d2f0)*(arg1->f0)
                        +2*(arg1->d1f0)*(arg2->d1f0);
                    break;};
	    case 's': { arg1->d2reval();
                    d2f0=arg1->d2f0*cos(arg1->f0)
                         -(arg1->d1f0)*(arg1->d1f0)*f0;
                    break;};
        case 'c': { arg1->d2reval();
                    d2f0=-(arg1->d2f0)*sin(arg1->f0)
                         -(arg1->d1f0)*(arg1->d1f0)*f0;
                    break;};
        case 'e': { arg1->d2reval();
                    d2f0=((arg1->d2f0)+(arg1->d1f0)*(arg1->d1f0))*f0;
                    break;};
        default : printf("Bogue d2reval\n");
    } ;
};


bool node::RetroPropagation(interval& Y) //renvoie faux si inconsistent
{    //if (!f.isInterval) return(true);
     if (Subset(f,Y)) return true;
     f=Inter(f,Y);
     bool b1,b2;
     if (f.isEmpty) return(false);
     switch (code)
	 {  case '0':  return true;
        case 'i':  return true;
	    case '-':  if (arg2==NULL) {arg1->RetroPropagation(-f);break;}
		           else
                   {    b1=arg1->RetroPropagation(arg2->f + f);
                        if (!b1) return (false);
                        b2=arg2->RetroPropagation(arg1->f - f);
                        return (b2);
                   };
	    case '+':  {    b1=arg1->RetroPropagation(f - arg2->f);
                        if (!b1) return (false);
                        b2=arg2->RetroPropagation(f - arg1->f);
                        return (b2);
                   };
	    case '*':  {    b1=arg1->RetroPropagation(f / arg2->f);
                        if (!b1) return (false);
                        b2=arg2->RetroPropagation(f / arg1->f);
                        return (b2);
                   };
	    case 'e':  {    b1=arg1->RetroPropagation(Log(f));
                        return (b1);
                   };

        default : printf("Bogue eval\n");
    } ;
};


void node::Print ()
{   if (code=='0')   {cout<<f; return; };
    if (code=='i')   {cout<<"p"<<i; return; };
    if ((code=='-')&&(arg2==NULL))
	    {cout<<'!';arg1->Print(); return; };
	if ((code=='+')||(code=='-')||(code=='*')||(code=='/'))
	   {arg1->Print();cout<<code;arg2->Print();return;};
	if (code=='2')  {cout<<"Sqr(";arg1->Print();cout<<")";return;};
	if (code=='s')  {cout<<"sin(";arg1->Print();cout<<")";return;};
	if (code=='c')  {cout<<"cos(";arg1->Print();cout<<")";return;};
	if (code=='e')  {cout<<"exp(";arg1->Print();cout<<")";return;};
};

void Delete(node* n)
{   if (n==NULL) return;
    if (n->called!=0) return;
    node* a1=n->arg1;
    node* a2=n->arg2;
    cout<<"\nDelete("<<n->code<<")";
    delete(n);
    if (a1!=NULL) {a1->called--; Delete(a1);}
    if (a2!=NULL) {a2->called--; Delete(a2);}
}

